# !/usr/bin/python3

import numpy as np
import glob
import glymur
import time

# Looking for reorganized data

files = glob.glob('/data/pics/*bin')
if not files:
    files = glob.glob('/data/pics/*tif')

files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

j = 0
cpt_all = []


# Each 3d block is reorganized as a 2D picture. Some zeros are added if it is necessary.

for file in files:
    data = np.fromfile(file, dtype='uint8', sep="")
    factors = []
    for i in range(1, int(len(data) + 1)):
        if len(data) % i == 0:
            factors.append(i)
    index = int(len(factors) / 2)

    cpt = 0

    while factors[index] < 32 or factors[index - 1] < 32:
        data = np.insert(data, len(data), 0)
        cpt += 1

        factors = []
        for i in range(1, int(len(data) + 1)):
            if len(data) % i == 0:
                factors.append(i)

        index = int(len(factors) / 2)

    data = np.array(data, dtype='uint8')

    data = data.reshape(-1, factors[index])

    jp2 = glymur.Jp2k('/data/compressed/Jp2/' + str(j) + '.jp2', data=data)
    j += 1
    cpt_all.append(cpt)

cpt_all = np.array(cpt_all)

output_file = open('/data/compressed/list_cpt.bin',
                   'wb')
cpt_all.tofile(output_file)
output_file.close()

