#!/usr/bin/python

import numpy as np
import sys
import zipfile
import zlib
import cv2
import glob
from skimage.util import view_as_blocks
import matplotlib.image as mpimg
from distutils.dir_util import copy_tree
from PIL import Image

# Fetching different parameters

name = sys.argv[1]
block_size = int(sys.argv[2])

flag = 0


# Looking for corresponding dataset

files = glob.glob('/data/' + str(name) + '/slices_8bit/*.tif')
files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

# Initialization of the 3d array and some counters

cpt = 0
cpt2 = 0
X_data = []

# Creation of the 3d array

for myFile in files:
    image = Image.open(myFile).convert('L')
    image.save('/data/source/' + str(cpt) + '.tif')
    image = np.array(image)
    X_data.append(image)
    cpt += 1

X_data = np.array(X_data)

size1, size2, size3 = X_data.shape[0], X_data.shape[1], X_data.shape[2]

if block_size == 0:
    copy_tree('/data/source/', '/data/pics/')


else:

    # Splitting the 3d array into smaller blocks according to desired block size

    Blocks = view_as_blocks(X_data, block_shape=(block_size, block_size, block_size))
    print(Blocks.shape)

    for i in range(0, int(X_data.shape[0] / block_size)):
        for j in range(0, int(X_data.shape[1] / block_size)):
            for k in range(0, int(X_data.shape[2] / block_size)):

                if flag == 0:
                    factors = []
                    for m in range(1, block_size * block_size * block_size):
                        if block_size * block_size * block_size % m == 0:
                            factors.append(m)
                    index = int(len(factors) / 2)
                    print(factors[index])

                    flag = 1

                block = Blocks[i, j, k].reshape(-1, factors[index])
                block_im = Image.fromarray(block)
                block_im.save('/data/pics/' + str(cpt2) + '.tif')
                cpt2 += 1
