import numpy as np
import sys
from PIL import Image
import glob
import matplotlib.pyplot as plt
from skimage.util import view_as_blocks
import matplotlib.image as mpimg
import shutil
import time
import cv2
import os
import tarfile
from pyunpack import Archive
import jpeg_ls
import h5py
import random
import glymur
import subprocess



def uncompressed(w, h, nb_pics, block_size):

    shutil.rmtree('/data/uncompressed')

    os.mkdir('/data/uncompressed')
    os.mkdir('/data/uncompressed/bin')
    os.mkdir('/data/uncompressed/7z')
    os.mkdir('/data/uncompressed/szip')
    os.mkdir('/data/uncompressed/webp')
    os.mkdir('/data/uncompressed/jp2')
    os.mkdir('/data/uncompressed/tar.bz2')
    os.mkdir('/data/uncompressed/tar.gz')
    os.mkdir('/data/uncompressed/tar.xz')
    os.mkdir('/data/uncompressed/jpls')
    os.mkdir('/data/uncompressed/png')
    os.mkdir('/data/uncompressed/h265')
    os.mkdir('/data/uncompressed/webm')

    os.mkdir('/data/uncompressed/bin/7z')
    os.mkdir('/data/uncompressed/bin/tar.bz2')
    os.mkdir('/data/uncompressed/bin/tar.gz')
    os.mkdir('/data/uncompressed/bin/tar.xz')
    os.mkdir('/data/uncompressed/bin/jp2')
    os.mkdir('/data/uncompressed/bin/jpls')
    os.mkdir('/data/uncompressed/bin/szip')
    os.mkdir('/data/uncompressed/bin/webp')
    os.mkdir('/data/uncompressed/bin/png')
    os.mkdir('/data/uncompressed/bin/h265')
    os.mkdir('/data/uncompressed/bin/webm')

    Methods = ['tar.gz', 'tar.bz2']
    Temps = []
    block_size = int(block_size)

    for i in Methods:

        start = time.time()

        if i == 'jp2':
            files = glob.glob('/data/compressed/Jp2/*.jp2')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
            cpt = np.fromfile('/data/compressed/list_cpt.bin', dtype='int')

            cpt2 = 0
            for file in files:

                jp2 = glymur.Jp2k(file)
                fullres = jp2[:]

                if cpt[cpt2] != 0:
                    while cpt[cpt2] != 0:
                        ind = len(fullres.flatten()) - 1
                        fullres = np.delete(fullres, ind)
                        cpt[cpt2] -= 1

                if block_size != 0:
                    output_file = open('/data/uncompressed/bin/jp2/' + str(cpt2) + '.bin',
                                       'wb')
                else:
                    output_file = open('/data/uncompressed/bin/jp2/' + str(cpt2) + '.tif',
                                       'wb')
                fullres.tofile(output_file)
                output_file.close()
                cpt2 += 1

            os.environ['OPENCV_IO_ENABLE_JASPER'] = 'True'

            A = cv2.imread(file, 0)
            if block_size != 0:
                output_file = open('//data/uncompressed/bin/jp2/' + str(cpt2) + '.bin',
                                   'wb')
            else:
                output_file = open('/data/uncompressed/bin/jp2/' + str(cpt2) + '.tif',
                                   'wb')
            A.tofile(output_file)
            output_file.close()
            cpt2 += 1

        elif i == 'jpls':
            files = glob.glob('/data/compressed/Jpls/*.bin')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
            cpt3 = 0
            for myFile in files:
                A = np.fromfile(myFile, dtype='uint8', sep="")
                decode = jpeg_ls.decode(A)
                if block_size == 0:
                    A = Image.fromarray(decode)
                    A.save('/data/uncompressed/bin/jpls/' + str(cpt3) + '.tif')
                else:
                    A = Image.fromarray(decode)
                    A.save('/data/uncompressed/bin/jpls/' + str(cpt3) + '.tif')
                cpt3 += 1

        elif i == 'szip':
            files = glob.glob('/data/compressed/Szip/*.h5')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
            cpt4 = 0
            for myFile in files:
                f = h5py.File(myFile, 'r')
                name = '/data/pics/' + str(
                    random.choice(os.listdir('/data/pics/')))

                if block_size == 0:

                    if 'no' in myFile:
                        name = '/data/pics/' + str(
                            random.choice(os.listdir('/data/pics/')))
                        while 'no' not in name:
                            name = '/data/pics/' + str(
                                random.choice(os.listdir('/data/pics/')))
                    else:
                        while 'no' in name:
                            name = '/data/pics/' + str(
                                random.choice(os.listdir('/data/pics/')))

                    A = Image.open(name)
                    A = np.array(A)
                    set = f.require_dataset('dset_szip', shape=A.shape, dtype='uint8')
                    A = np.array(set)
                    A = Image.fromarray(A)
                    A.save('/data/uncompressed/bin/szip/' + str(cpt4) + '.tif')
                else:

                    if 'no' in myFile:
                        while 'no' not in name:
                            name = '/data/pics/' + str(
                                random.choice(os.listdir('/data/pics/')))
                    else:
                        while 'no' in name:
                            name = '/data/pics/' + str(
                                random.choice(os.listdir('/data/pics/')))

                    A = np.fromfile(name, dtype='uint8', sep="")
                    A_shape = A.shape[0]
                    set = f.require_dataset('dset_szip', shape=(A_shape,), dtype='uint8')
                    A = np.array(set)
                    output_file = open('/data/uncompressed/bin/szip/' + str(cpt4) + '.bin',
                                       'wb')

                    A.tofile(output_file)
                    output_file.close()
                cpt4 += 1

        elif i == 'webp':
            files = glob.glob('/data/compressed/Webp/*.webp')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
            cpt5 = 0
            for file in files:
                try:
                    A = Image.open(file).convert('L')
                except:
                    break

                if block_size != 0:
                    A.save('/data/uncompressed/bin/webp/' + str(cpt5) + '.tif')
                else:
                    A.save('/data/uncompressed/bin/webp/' + str(cpt5) + '.tif')

                cpt5 += 1

        elif i == 'png':
            files = glob.glob('/data/compressed/Png/*.png')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
            cpt5 = 0
            for file in files:
                try:
                    A = Image.open(file)
                except:
                    break

                if block_size != 0:
                    A = np.array(A)
                    output_file = open('/data/uncompressed/bin/png/' + str(cpt5) + '.bin',
                                       'wb')
                    A.tofile(output_file)
                    output_file.close()
                else:
                    A.save('/data/uncompressed/bin/png/' + str(cpt5) + '.tif')

                cpt5 += 1

        elif i == 'h265':
            bashCommand = "bash decompress-h265-tif.sh "

            process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
            output, error = process.communicate()

    
        elif i == 'webm':
            if block_size != 0:
                bashCommand = "bash decompress-webm-bin.sh "
            else:
                bashCommand = "bash decompress-webm-tif.sh "
            process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
            output, error = process.communicate()

        else:

            files = glob.glob('/data/compressed/Tar.gz/*.gz')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

            for file in files:
                Archive(file).extractall(
                    '/data/uncompressed/bin/tar.gz')

            files = glob.glob('/data/compressed/Tar.bz2/*.bz2')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

            for file in files:
                Archive(file).extractall(
                    '/data/uncompressed/bin/tar.bz2')


        if i == '7z':
            files = glob.glob('/data/uncompressed/bin/7z/pics/*.bin')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

        elif i == 'tar.gz':
            files = glob.glob('/data/uncompressed/bin/tar.gz/data/pics/*.tif')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

        elif i == 'tar.bz2':
            files = glob.glob('/data/uncompressed/bin/tar.bz2/data/pics/*.tif')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

        else:
            files = glob.glob('/data/uncompressed/bin/' + str(i) + '/*.tif')
            files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

        if block_size != 0:

            Block2 = np.zeros(
                (int(nb_pics / block_size), int(h / block_size), int(w / block_size), block_size, block_size,
                 block_size))
            cpt1 = cpt2 = cpt3 = 0

            for myFile in files:
                A = Image.open(myFile).convert('L')
                A = np.array(A)
                A = A.reshape(block_size, block_size, block_size)
                Block2[cpt1, cpt2, cpt3] = A
                cpt3 += 1
                if cpt3 == w / block_size:
                    cpt2 += 1
                    cpt3 = 0
                if cpt2 == h / block_size:
                    cpt1 += 1
                    cpt2 = 0
                if cpt1 == nb_pics / block_size:
                    cpt1 = 0

            Recons = np.dstack(np.dstack(np.dstack(Block2)))

            for m in range(nb_pics):
                img = Image.fromarray((255 - (Recons[m, :, :] * 255) + 1).astype(np.uint8))
                img.save('/data/uncompressed/' + str(i) + '/' + str(m) + '.tif',
                         format="TIFF")
        end = time.time()
        Temps.append(str(round(end - start, 4)))

    return Temps
