import xlsxwriter
import subprocess
import os
import shelve
import sys
import os.path
from PIL import Image
import numpy as np
import glob
import cv2
from skimage.measure import compare_ssim as ssim
import matplotlib.pyplot as plt
from decimal import Decimal
import glymur
import shutil


def lossy_h265(file, q, cpt):
    bashCommand = 'ffmpeg  -hide_banner -loglevel warning -i ' + str(file) + ' -c:v libx265 -crf ' + str(
        q) + ' /data/compressed2/' + str(cpt) + '.mp4 '

    process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
    output, error = process.communicate()


def get_size(start_path='.'):
    total_size = 0
    for dirpath, dirnames, filenames in os.walk(start_path):
        for f in filenames:
            fp = os.path.join(dirpath, f)
            if not os.path.islink(fp):
                total_size += os.path.getsize(fp)

    return total_size


#  Creation of an excel file to store all the results

workbook = xlsxwriter.Workbook('BPG.xlsx')
worksheet = workbook.add_worksheet()

#  Initialization

Metric = ['Butteraugli']
Methods = ['Webp', 'Jp2', 'H265', 'Guetzli']

names = [['Data', 'Butteraugli_value', 'Quality_param', 'Ratio']]

tab_values = []

Datas = ['Archie_04', 'Probe_7', 'Z275', 'C7', 'Pseudoskorpion', 'Eucrib_03', 'Gama_01']


for d in Datas:

    os.mkdir('/data/compressed3')
    os.mkdir('/data/bpg')

    line = [d]
    files = glob.glob('/data/' + str(d) + '/slices_8bit/*.tif')
    files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))

    files2 = glob.glob('/data/unproc_slices/' + str(d) + '/*.tif')

    output = 0

    q = 100

    q2 = 1

    while output <= 1.5:
        butter = output
        val_final = q2

        print('val', float(output))
        print('quality', q2)

        img = cv2.imread(files2[0], 0)

        cv2.imwrite('/data/bpg/0_0.png', img)

        bashCommand = 'bpgenc /data/bpg/0_0.png -q ' + str(q2) + '  -o /data/bpg/' + str(q2) + '.bpg'

        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()

        bashCommand = 'bpgdec /data/bpg/' + str(q2) + '.bpg -o /data/bpg/' + str(q2) + '.png'

        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()

        bashCommand = "butteraugli /data/bpg/0_0.png /data/bpg/" + str(q2) + ".png"
        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()
        output = str(output)
        output = float(output[2:8])

        q2 += 1

    cpt = 0

    print('final', val_final)

    line.append(butter)
    line.append(val_final)

    for myFile in files:
        file = cv2.imread(myFile, 0)

        cv2.imwrite('/data/bpg/0_0.png', file)

        bashCommand = 'bpgenc /data/bpg/0_0.png -q ' + str(val_final) + '  -o /data/compressed3/' + str(
            cpt) + '.bpg'

        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()

        cpt += 1

    original_size = get_size('/data/' + str(d))
    compressed_size = get_size('/data/compressed3')
    ratio = original_size / compressed_size

    line.append(ratio)

    names.append(line)

    shutil.rmtree('/data/compressed3')
    shutil.rmtree('/data/bpg')

#  Filling arrays and columns of the excel file with data


for i in range(0, len(Datas) + 1):
    for j in range(0, len(names[0])):
        worksheet.write(i, j, names[i][j])
        worksheet.set_column(i, j, len(str('Butteraugli_value')))

workbook.close()
