import xlsxwriter
import subprocess
import os
import shelve
import sys
import os.path
from PIL import Image
import numpy as np
import glob
import cv2
from skimage.measure import compare_ssim as ssim
import matplotlib.pyplot as plt
from decimal import Decimal
from guetzli_tests import lossy_guetzli
import glymur
import shutil


def get_size(start_path='.'):
    total_size = 0
    for dirpath, dirnames, filenames in os.walk(start_path):
        for f in filenames:
            fp = os.path.join(dirpath, f)
            if not os.path.islink(fp):
                total_size += os.path.getsize(fp)

    return total_size


#  Creation of an excel file to store all the results

workbook = xlsxwriter.Workbook('Guetzli.xlsx')
worksheet = workbook.add_worksheet()

#  Initialization

Metric = ['Butteraugli']
Methods = ['Webp', 'Jp2', 'H265', 'Guetzli']

names = [['Data', 'Butteraugli_value', 'Quality_param', 'Ratio']]

tab_values = []

Datas = ['Archie_04', 'Probe_7', 'Z275', 'C7', 'Pseudoskorpion', 'Eucrib_03', 'Gama_01', 'Screwjoint']


for d in Datas:

    os.mkdir('/data/compressed8')
    os.mkdir('/data/guetzli2')

    line = [d]
    files = glob.glob('/data/processed/' + str(d) + '/*.tif')
    files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
    files2 = glob.glob('/data/proc_slices/' + str(d) + '/*.tif')

    output = 0

    q = 100

    q2 = 1

    while output <= 1.5:
        butter = output
        val_final = q

        print('val', float(output))
        print('quality', q)

        img = cv2.imread(files2[0], 0)
        cv2.imwrite('/data/guetzli2/0.png', img)

        lossy_guetzli(files2[0], q)

        bashCommand = "butteraugli /data/guetzli2/0.png /data/guetzli2/" + str(q) + ".jpg"
        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()
        output = str(output)
        output = float(output[2:8])

        q -= 1

    cpt = 0

    print('final', val_final)

    line.append(butter)
    line.append(val_final)

    for myFile in files2:
        file = cv2.imread(myFile, 0)

        cv2.imwrite('/data/guetzli2/0.png', file)

        bashCommand = "guetzli --quality " + str(
            val_final) + " /data/guetzli2/0.png /data/compressed8/" + str(
            cpt) + ".jpg"
        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()

        cpt += 1

    original_size = get_size('/data/proc_slices/' + str(d))
    compressed_size = get_size('/data/compressed8')
    ratio = original_size / compressed_size

    line.append(ratio)

    names.append(line)

    shutil.rmtree('/data/compressed8')
    shutil.rmtree('/data/guetzli2')


#  Filling arrays and columns of the excel file with data


for i in range(0, len(Datas) + 1):
    for j in range(0, len(names[0])):
        worksheet.write(i, j, names[i][j])
        worksheet.set_column(i, j, len(str('Butteraugli_value')))

workbook.close()
