import xlsxwriter
import subprocess
import os
import shelve
import sys
import os.path
from PIL import Image
import numpy as np
import glob
import cv2
from skimage.measure import compare_ssim as ssim
import matplotlib.pyplot as plt
from decimal import Decimal
import glymur
import shutil


def get_size(start_path='.'):
    total_size = 0
    for dirpath, dirnames, filenames in os.walk(start_path):
        for f in filenames:
            fp = os.path.join(dirpath, f)
            if not os.path.islink(fp):
                total_size += os.path.getsize(fp)

    return total_size


#  Creation of an excel file to store all the results

workbook = xlsxwriter.Workbook('Webp.xlsx')
worksheet = workbook.add_worksheet()

#  Initialization

Metric = ['Butteraugli']
Methods = ['Webp', 'Jp2', 'H265', 'Guetzli']

names = [['Data', 'Butteraugli_value', 'Quality_param', 'Ratio']]

tab_values = []

Datas = ['Archie_04','Probe_7',  'Z275',   'C7','Pseudoskorpion','Eucrib_03','Gama_01','Screwjoint']


for d in Datas:

    os.mkdir('/data/compressed2')
    os.mkdir('/data/webp')

    line = [d]
    files = glob.glob('/data/' + str(d) + '/slices_8bit/*.tif')
    files.sort(key=lambda x: int(''.join(filter(str.isdigit, x))))
    
    files2 = glob.glob('/data/unproc_slices/' + str(d) + '/*.tif')
    output = 0

    q = 100

    q2 = 1

    while output <= 1.5:
        butter = output
        val_final = q

        print('val', float(output))
        print('quality', q)

        img = cv2.imread(files2[0], 0)

        cv2.imwrite('/data/webp/0.png', img)

        img2 = Image.fromarray(img)

        img2.save('/data/webp/'+str(q)+'.webp', lossless=False, quality=q)

        E = Image.open('/data/webp/'+str(q)+'.webp').convert('L')
        E = np.array(E)


        cv2.imwrite('/data/webp/' + str(q) + '.png', E)

        bashCommand = "butteraugli /data/webp/0.png /data/webp/" + str(q) + ".png"
        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()
        output = str(output)
        output = float(output[2:8])

        q -= 1

    cpt = 0

    print('final', val_final)

    line.append(butter)
    line.append(val_final)

    for myFile in files:
        file = cv2.imread(myFile, 0)

        img2 = Image.fromarray(file)

        img2.save('/data/compressed2/' + str(cpt) + '.webp', lossless=False, quality=val_final)

        cpt += 1

    original_size = get_size('/data/'+str(d))
    compressed_size = get_size('/data/compressed2')
    ratio = original_size / compressed_size

    line.append(ratio)

    names.append(line)

    shutil.rmtree('/data/compressed2')
    shutil.rmtree('/data/webp')

#  Filling arrays and columns of the excel file with data


for i in range(0, len(Datas)+1):
    for j in range(0, len(names[0])):

        worksheet.write(i, j, names[i][j])
        worksheet.set_column(i, j, len(str('Butteraugli_value')))

workbook.close()
