import xlsxwriter
import subprocess
import os
import shelve
import sys
import time
import re

#  Creation of an excel file to store all the results

workbook = xlsxwriter.Workbook('Compression_tileDB.xlsx')

#  Initialization

Methods = ['LZ4', 'Zstd', 'Gzip', 'Bzip2']
Datas = ['Eucrib_03', 'Gama_01', 'Z275', 'Archie_04', 'C7', 'Probe_7', 'Pseudoskorpion', 'Screwjoint']

Tiles = [0]

# For each data set TileDB1 program is run and the results are fetched.

for k in Datas:
    worksheet = workbook.add_worksheet()

    Infos = [k]
    Ratios = [Methods[0]]
    Total = []
    for j in Methods:
        Ratios = [j]
        for i in Tiles:
            if i not in Infos:
                Infos.append(i)
            bashCommand = "python TileDB1.py " + str(k) + ' ' + str(j) + ' ' + str(i)
            print(bashCommand)
            process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
            output, error = process.communicate()
            output = str(output)
            index = output.find('Write compression ratio')
            Ratio = output[index + 40:index + 70]
            Ratio = str(re.findall("\d+\.\d+", Ratio)).strip('[]')
            print('Ratio', Ratio)
            Ratios.append(Ratio)

        Total.append(Ratios)

    Data = (Infos,
            Total[0],
            Total[1],
            Total[2],
            Total[3]
            )

    h, w = len(Data), len(Data[0])

    #  Filling rows and columns of the excel file with obtained results

    for i in range(0, h):
        for j in range(0, w):
            worksheet.write(i, j, Data[i][j])

workbook.close()
